   --     
   -- (   )
   -- [,2002,.119]
   -- *************************
   msort :: Ord a => [a] -> [a]
   msort xs | length xs<=1 = xs
            | True         = merge2 (msort ys) (msort zs)
      where ys   = take half xs
            zs   = drop half xs
            half = length xs `div` 2
   -----------------------------------
   merge2:: Ord a => [a] -> [a] -> [a]
   merge2 [] ys = ys
   merge2 xs [] = xs
   merge2 (x:xs) (y:ys) | x<=y = x : merge2   xs   (y:ys)
                        | True = y : merge2 (x:xs)   ys
   ----------------------------------------------------
   --    
   --  
   -- (    )
   ----------------------------------------------
   mSort l | len<2 = l
           | True  = mer (mSort (take m l))
                         (mSort (drop m l))
         where len = length l
               m   = len `div` 2
   --------------------------------------------
   mer (a:x) (b:y) | a<=b = a : mer x     (b:y)
                   | True = b : mer (a:x) y
   mer (a:x) [] = (a:x)
   mer []    y  = y
   -- ***************************
   --   :
   ------------------------------------------------
   test1 = msort [7,6,5,4,3,2,1] == [1,2,3,4,5,6,7]
   ----------------------------------------------------------
   test2 =   merge2 [1,5,8,9] [2,3,8,9]  == [1,2,3,5,8,8,9,9]
          && merge2 [1,5,8,9] [10,23,54] == [1,5,8,9,10,23,54]
   -----------------------------------------------------------
   test3 = mSort [7,6,5,4,3,2,1] == [1,2,3,4,5,6,7]
   -------------------------------------------------------
   test4 =   mer [1,5,8,9] [2,3,8,9]  == [1,2,3,5,8,8,9,9]
          && mer [1,5,8,9] [10,23,54] == [1,5,8,9,10,23,54]
